#!/usr/bin/python3

from flask import request, render_template
from socket import gethostbyaddr
from flask import Flask

import json
import binascii
import os
import sqlite3

app = Flask(__name__)

@app.route("/")
def index():
    remote_addr = request.remote_addr
    hostname = remote_addr
    try:
        hostname = gethostbyaddr(remote_addr)[0]
    except:
        pass

    token=os.urandom(16)
    token='tok' + binascii.hexlify(token).decode()
    
    return render_template("index.html", remote_addr=remote_addr, hostname=hostname, token=token)

@app.route("/api")
def api():
    remote_addr = request.remote_addr
    hostname = remote_addr
    try:
        hostname = gethostbyaddr(remote_addr)[0]
    except:
        pass
        
    data = {
        'ipaddress' : remote_addr,
        'hostname'  : hostname
    }
    return json.dumps(data)

@app.route("/named/<token>")
def named(token):
    sqlite = sqlite3.connect("tokens.sqlite")
    response = []
    with sqlite:
        cur = sqlite.cursor()
        cur.execute("SELECT DISTINCT ip FROM token WHERE token = ?", (token, ))
        for row in cur:
            hostname = row[0]
            try:
                hostname = gethostbyaddr(hostname)[0]
            except:
                pass

            response.append((row[0], hostname))

    print(response)
    return json.dumps(response)
        
